﻿-- Author      : Korax
-- Create Date : 8/31/2008 4:54:56 PM

expression = "0";
lastCommand = "num";
lastOp = "";
lastDivIdx = 0;
dotPunched = false;

function Button1_OnClick()
	numClick("1");	
end

function Button2_OnClick()
	numClick("2");	
end

function Button3_OnClick()
	numClick("3");	
end

function Button4_OnClick()
	numClick("4");	
end

function Button5_OnClick()
	numClick("5");	
end

function Button6_OnClick()
	numClick("6");	
end

function Button7_OnClick()
	numClick("7");	
end

function Button8_OnClick()
	numClick("8");	
end

function Button9_OnClick()
	numClick("9");	
end

function Button0_OnClick()
	numClick("0");	
end

function ButtonAdd_OnClick()
	opClick("+");
end

function ButtonSub_OnClick()
	opClick("-");
end

function ButtonMult_OnClick()
	opClick("*");
end

function ButtonDiv_OnClick()
	opClick("/");
end

function ButtonDot_OnClick()
	if (lastCommand == "num" and dotPunched == false ) then
		expression = expression .. ".";
		lastCommand = "num";
		updateVisor(expression);
		dotPunched = true;
	elseif ( FontString1:GetText() == "0" and dotPunched == false ) then
		expression = "0.";
		lastCommand = "num";
		updateVisor(expression);
		dotPunched = true;
	elseif ( lastCommand == "op" and dotPunched == false ) then
		expression = expression .. "0.";
		lastCommand = "num";
		updateVisor(expression);
		dotPunched = true;	
	end
end

function ButtonEq_OnClick()
	if (expression ~= "" and checkDivZero() == true) then
		if (lastCommand == "op" ) then
			expression = string.sub(expression,1,string.len(expression)-1);	
			RunScript('solve("'.. expression ..' = " .. ' .. expression .. ')');
		else
			RunScript('solve("'.. expression ..' = " .. ' .. expression .. ')');
		end
		lastCommand = "num";
	end
end

function checkDivZero()
	if ( lastOp == "/" and lastDivIdx < string.len(expression) ) then
		rightOperand = tonumber(string.sub(expression,lastDivIdx+1,string.len(expression)));
		if ( rightOperand == 0 ) then
			updateVisor("Cannot divide by 0. Reset.");
			lastCommand = "num";
			dotPunched = false;
			expression = "0";
			lastOp = "";
			lastDivIdx = 0;
			return false;
		end
	end
	return true;			
end

function numClick(num)	
	if ( FontString1:GetText() == "0" ) then
		expression = num;
	else
		expression = expression .. num;
	end
	lastCommand = "num";
	updateVisor(expression);
end

function opClick(op)
	if (lastCommand == "num" or FontString1:GetText() == "0" ) then
		expression = expression .. op;
	else
		expression = string.sub(expression,1,string.len(expression)-1);
		expression = expression .. op;
	end
	if ( op == "/" ) then
		lastDivIdx = string.len(expression);
	end
	lastCommand = "op";
	lastOp = op;
	dotPunched = false;
	updateVisor(expression);
end

function ButtonReset_OnClick()
	reset();
end

function ButtonDel_OnClick()
	if ( string.len(expression) ~= 0 ) then
		lastChar = string.sub(expression,string.len(expression),string.len(expression));
		preLastChar = "";
		if (string.len(expression) > 1 ) then
			preLastChar = string.sub(expression,string.len(expression)-1,string.len(expression)-1);
		end
		expression = string.sub(expression,1,string.len(expression)-1);
		if ( lastChar == '.' ) then
			dotPunched = false;
		end
		if ( preLastChar == '+' or preLastChar == '-' or preLastChar == '/' or preLastChar == '*' ) then
			lastCommand = "op"
		end	
	end
	if ( string.len(expression) == 0 ) then
		reset();
	end
	updateVisor(expression);
end

function reset()
	FontString1:SetText("0");
	lastCommand = "num";
	dotPunched = false;
	expression = "0";
	lastOp = "";
	lastDivIdx = 0;
end

function updateVisor(str)
	FontString1:SetText(str);
end

function myPrint(...)
	local argCount = select("#",...);
	for i = 1 , argCount do
		local arg = select(i,...);
		DEFAULT_CHAT_FRAME:AddMessage( "arg[" .. i .. "] = " .. arg);
	end
end

function solve(ans)
	expression = string.sub(ans,string.len(expression)+4,string.len(ans));
	down = tonumber(expression);
	downFloor = floor(down);	
	if ( down ~= downFloor ) then
		dotPunched = true;
	end
	FontString1:SetText(ans);
end

function Frame1_OnLoad()
	SLASH_KORCALC1 = "/calc";
	SlashCmdList["KORCALC"] = KorCalc_Cmd;
	tinsert(UISpecialFrames,"Frame1");	
	DEFAULT_CHAT_FRAME:AddMessage( "myCalc 1.3 loaded. To launch, type: /calc",1,1,0);	
	Frame1:Hide();
end

function KorCalc_Cmd()		
	if (Frame1:IsVisible()) then
		Frame1:Hide();
	else
		Frame1:Show();
	end
end

function Frame1_OnMouseUp()
	if ( Frame1.isMoving ) then
		Frame1:StopMovingOrSizing();
		Frame1.isMoving = false;
	end
end

function Frame1_OnMouseDown()
	if ( ( ( not Frame1.isLocked ) or ( Frame1.isLocked == 0 ) ) and ( arg1 == "LeftButton" ) ) then
		Frame1:StartMoving();
		Frame1.isMoving = true;
	end
end

function Frame1_OnHide()
	if ( Frame1.isMoving ) then
		Frame1:StopMovingOrSizing();
		Frame1.isMoving = false;
	end
end